/******************************************************************
 * ep-mine-app-array.c
 * - n񔭌葱Fo̔z
 * - Created on 14 FEB 2004 by {arim,y-uchida}@i.kyushu-u.ac.jp
 *   based on ep-app-list.c 
 * - ep-approx-list-all2.c: 
 *   Created on 4 FEB 2004 by {uchida,arim}@i.kyushu-u.ac.jp.
 *   based on ep-approx-list-all.c 
 * $Id: ep-mine-app-array.c,v 1.4 2004/02/25 20:31:59 arim Exp $
 ******************************************************************/

#include "ap-util.h"
#include "ap-carray.h"
#include "ap-iarray.h"
#include <assert.h>
#include <stdlib.h>
#include <time.h>
#include <math.h>
#include "ep-mine-api.h"

/*
 * Search: Algorithm Specific Part
 */

int update(char e, Occdb occ, Line line)
{
  int i;
  int M;
  int EX, INS, DEL;
  int ED;
  Occdb newocc;
  char x;
  bool flag;
  int min_k = INTMAX; //by arim on 25feb04

  M = line->len;
  //newocc = ia_alloc(MAX_IARRAY);
  newocc = ia_alloc(line->len + IA_MARGIN);

  ia_push_back(newocc, occ->val[0] + MAXDEL);//gamma(e->epsilon)
  flag = false;

  for (i = 0; i < M; i++) {
    x = line->val[i];
    if (x == e){
	  ED = occ->val[i];
      ia_push_back(newocc, ED);
    } else {
	  EX  = MAXEX + occ->val[i];//gamma(e->x)
	  INS = MAXINS + newocc->val[i];//gamma(epsilon->x)
	  DEL = MAXDEL + occ->val[i+1];//gamma(e->epsilon)
	  
	  /*       if (EX < INS) ED = EX;//ED=minimum(EX,INS,DEL) */
	  /*       else ED = INS; */
	  /*       if (ED > DEL) ED = DEL; */
	  ED = min(EX, INS);
	  ED = min(ED, DEL);
	  ia_push_back(newocc, ED);
    } //end if
	//if (ED <= k) 
	//  flag = true;
	min_k = min(min_k, ED); //by arim
  }
#ifdef USE_MINSCORE
	newocc->minelem = min_k;
#endif
	//if (!flag) //No safe occurrence
	//  ia_make_null(newocc);
  return (int) newocc;
}


static void update_db(Occdb occdb, Occdb newoccdb, char event, Database database, int maxscore) {
  int j;
  Occdb occ, newocc;
  Line line;
  for (j = 0; j < database->len; j++) {
	line  = (Line) database->val[j];
	occ   = (Occdb) occdb->val[j];
	if (occ->len > 0){
	  newocc = (Occdb) update(event, occ, line);
	  if (newocc->minelem > maxscore) //No safe occurrence
		ia_make_null(newocc);
	} else{
	  newocc = ia_alloc(0); //󃊃Xg
	}
	ia_push_back(newoccdb, (int) newocc);
  }
}

static void occdb_free(Occdb occdb) {
  int i;
  Occdb occ;
  for (i = 0; i < occdb->len; i++) {
	occ = (Occdb) occdb->val[i];
	ia_free(occ);
  }
  ia_free(occdb);
}

void compute_freq(Occdb occdb, int *_freq, int *_np_freq) {
  int i, freq = *_freq, np_freq = *_np_freq;
  Occdb occ;
  for (i = 0; i < occdb->len; i++){
    occ = (Occdb) occdb->val[i];
    if (occ->len > 0) {
      freq++;
	  np_freq += occ->len;
    }
  }
  *_freq = freq;
  *_np_freq = np_freq;
}

void compute_freq_minscore(Occdb occdb, int *_freq, int *_np_freq, int *_min_k, int *_max_k, int *_sum_k) {
  int i, freq = *_freq, np_freq = *_np_freq;
  Occdb occ;
  int min_k = *_min_k, max_k = *_max_k, sum_k = *_sum_k;
  for (i = 0; i < occdb->len; i++){
    occ = (Occdb) occdb->val[i];
    if (occ->len != 0) {
      freq++;
	  np_freq += occ->len;
	  min_k = min(min_k, occ->minelem);
	  max_k = max(max_k, occ->minelem);
	  sum_k = sum_k + occ->minelem;
    }
  }
  *_freq = freq;
  *_np_freq = np_freq;
  *_min_k = min_k;
  *_max_k = max_k;
  *_sum_k = sum_k;
}

void expand(Episode episode, Eventset eventset, Occdb occdb, Database database, int minsup, int maxscore)
{
  int i, j;
  int freq = 0, np_freq = 0;
  Episode newepisode;
  Occdb   newoccdb;
  Occdb   occ, newocc;
  Line    line;
  char    event;

#ifdef USE_MINSCORE
  int min_k = INTMAX;
  int max_k = 0;
  int sum_k = 0;
#endif
  
#ifdef USE_MINSCORE
  compute_freq_minscore(occdb, &freq, &np_freq, &min_k, &max_k, &sum_k);
#else
  compute_freq(occdb, &freq, &np_freq);
#endif
  //printf("freq = %d\n", freq);

  //Pruning by minsup
#ifdef USE_MINSCORE
  if (freq < minsup || min_k > minscore) {
#else
  if (freq < minsup) {
#endif
    ca_free(episode);
	occdb_free(occdb);
    return;
  }

	//Process pattern
	np_freq = (int)(np_freq*1.0); //modified by arim
#ifdef USE_MINSCORE
	if (occdb->len == 0) {
		printf("error: expand: occdb->len == 0 !\n");
		exit(0);
	}
	epsode_print(episode, freq, np_freq,
				 (float)sum_k/(float)occdb->len,
				 max_k, min_k);
#else
	epsode_print(episode, freq, np_freq);
#endif
	np[episode->len]++;
	npsum[episode->len] += freq; //document frequecy
	npsqr[episode->len] += freq * freq; //sqr of document frequecy

  for (i = 0; i < eventset->len; i++) {
		//VqGs\[h
    newepisode = ca_alloc(0);
    ca_copy(newepisode, episode);
    ca_push_back(newepisode, eventset->val[i]);
    //newoccdb = ia_alloc(MAX_IARRAY);
    newoccdb = ia_alloc(database->len + IA_MARGIN);

	event = (char) eventset->val[i];
	update_db(occdb, newoccdb, event, database, maxscore  - DELTA_WIN);
    expand(newepisode, eventset, newoccdb, database, minsup, maxscore - DELTA_WIN);
  }
  free(episode);
  occdb_free(occdb);
}

void episode_mine(Eventset eventset, Database database, int minsup, int maxscore)
{
  Occdb occdb;
  Occdb occ;
  Episode episode;
  Line line;
  int i, j;
  
  episode = ca_alloc(0);
  occdb = ia_alloc(MAX_IARRAY);
  
  for (i = 0; i < database->len; i++) {
    line = (Line) database->val[i];
    occ = ia_alloc(line->len + IA_MARGIN);
		/*     occ = ia_alloc(MAX_IARRAY); */
    for (j = 0; j <= line->len; j++) {
      ia_push_back(occ, 0); //set score zero
    }
    ia_push_back(occdb, (int) occ);
  }

  expand(episode, eventset, occdb, database, minsup, maxscore);
}

/* EOF */

